require "import"
import "android.app.*"
import "android.content.*"
import "android.speech.RecognizerIntent"
import "android.speech.tts.TextToSpeech"
import "android.net.Uri"

local Locale = luajava.bindClass("java.util.Locale")
local tts

function initTTS()
  tts = TextToSpeech(activity, TextToSpeech.OnInitListener{
    onInit = function(status)
      if status == TextToSpeech.SUCCESS then
        tts.setLanguage(Locale("ro"))
      end
    end
  })
end

function speakText(text)
  if tts then tts.speak(text, TextToSpeech.QUEUE_FLUSH, nil, "ttsID") end
end

function startVoiceRecognition()
  local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ro-RO")
  intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Spune numele aplicației...")
  activity.startActivityForResult(intent, 1)
end

function openPlayStore(query)
  local url = "https://play.google.com/store/search?q=" .. query:gsub(" ", "+") .. "&c=apps"
  activity.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse(url)))
  speakText("> Am căutat aplicația: " .. query)
end

function onActivityResult(requestCode, resultCode, data)
  if requestCode == 1 and resultCode == -1 and data then
    local matches = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS)
    if matches and matches.size() > 0 then
      openPlayStore(matches.get(0))
    end
  end
end

function onCreate()
  initTTS()
  startVoiceRecognition()
end